#define MAXCHILD		20
#define CONNECT_TIMEOUT		10

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdlib.h>
#include <signal.h>
#include <string.h>
#include <malloc.h>
#include <stdio.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

pid_t wait (int *status);

int sock;
char *flowbuf;

void
connect_read_timeout ()
{
  close (sock);
}

void
checkout (struct in_addr ip, int port)
{
  struct sockaddr_in sa;


  memset (&sa, 0, sizeof (sa));
  memcpy (&sa.sin_addr, &ip, 4);
  sa.sin_port = htons (port);

  if ((sock = socket (AF_INET, SOCK_STREAM, 0)) == -1)
    exit (0);

  signal (SIGALRM, connect_read_timeout);
  alarm (CONNECT_TIMEOUT);
  if (connect (sock, (struct sockaddr *) &sa, sizeof (sa)) == -1)
    {
      alarm (0);
      close (sock);
      exit (0);
    }
  alarm (0);
  printf ("%s\n", inet_ntoa (ip));
  exit (0);
}

void
main (int ac, char **av)
{
  char ipS[256];
  struct in_addr ip;
  int childs = 0, port = 53;

  if (ac == 2)
    if (atoi (av[1]) > 0)
      port = atoi (av[1]);
//signal(SIGCHLD,SIG_IGN);
  signal (SIGHUP, SIG_IGN);
  signal (SIGTERM, SIG_IGN);
  while (fgets (ipS, sizeof (ipS), stdin) != NULL)
    if (inet_aton (ipS, &ip) != 0 && ip.s_addr != 0)
      {
	if (childs >= MAXCHILD)
	  wait (NULL);
	switch (fork ())
	  {
	  case 0:
	    checkout (ip, port);
	    exit (0);
	  case -1:
	    perror ("fork");
	    exit (-1);
	  default:
	    childs++;
	    break;
	  }
      }
  while (childs--)
    wait (NULL);

  return;
}
